import _extends from "@babel/runtime/helpers/esm/extends";
import { jsx as _jsx } from "react/jsx-runtime";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import PropTypes from 'prop-types';

var ActionButton = function ActionButton(_ref) {
  var children = _ref.children,
      href = _ref.href,
      target = _ref.target,
      disabled = _ref.disabled,
      isSubmit = _ref.isSubmit,
      isButton = _ref.isButton,
      link = _ref.link,
      Link = _ref.linkFactory,
      attrs = _objectWithoutPropertiesLoose(_ref, ["children", "href", "target", "disabled", "isSubmit", "isButton", "link", "linkFactory"]);

  if (isSubmit) attrs.type = 'submit';
  if (isButton) attrs.type = 'button';
  return link ? /*#__PURE__*/_jsx(Link, _extends({}, attrs, {
    href: href,
    target: target,
    rel: target === '_blank' ? 'noopener' : undefined,
    children: children
  })) : /*#__PURE__*/_jsx("button", _extends({}, attrs, {
    disabled: disabled,
    children: children
  }));
};

ActionButton.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Content to be included in the button
   */
  children: PropTypes.node,

  /**
   * Disable: faded with no interaction.
   */
  disabled: PropTypes.bool,

  /**
   * URL to be added on the HTML link
   */
  href: PropTypes.string,

  /**
   * HTML element: if true, render a link. Otherwise render a button
   */
  link: PropTypes.bool,

  /**
   * Factory used to create navigation links
   */
  linkFactory: PropTypes.func,

  /**
   * if true, type="submit" (needed when several buttons coexist under the same form)
   */
  isSubmit: PropTypes.bool,

  /**
   * if true, type="button" (needed when several buttons coexist under the same form)
   */
  isButton: PropTypes.bool,

  /**
   * Target to be added on the HTML link
   */
  target: PropTypes.string
} : {};
ActionButton.defaultProps = {
  // eslint-disable-next-line react/prop-types
  linkFactory: function linkFactory(_temp) {
    var _ref2 = _temp === void 0 ? {} : _temp,
        children = _ref2.children,
        rest = _objectWithoutPropertiesLoose(_ref2, ["children"]);

    return /*#__PURE__*/_jsx("a", _extends({}, rest, {
      children: children
    }));
  }
};
export default ActionButton;